Multiscroll.PrefsObserver = function(parent) {
	this.parent = parent;
	try {
		var mprefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch(null);
		mprefs.QueryInterface(Components.interfaces.nsIPrefBranchInternal).addObserver(this.domain, this, false);
	} catch (ex) {
		;
	}
};

Multiscroll.PrefsObserver.prototype = {
	prefs : Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("multiscroll."),
	domain : "multiscroll",
	
	// handle changes in settings
	observe : function(subject, topic, pname) { with (this) {
		try {
			if (pname.split('.')[0] != this.domain) return;
			switch (pname.split('.')[1]) {
				case "activateShiftOn":
					parent.event.activate.shift = prefs.getBoolPref("activateShiftOn");
					break;
				case "activateCtrlOn":
					parent.event.activate.ctrl = prefs.getBoolPref("activateCtrlOn");
					break;
				case "activateAltOn":
					parent.event.activate.alt = prefs.getBoolPref("activateAltOn");
					break;
				case "activateMetaOn":
					parent.event.activate.meta = prefs.getBoolPref("activateMetaOn");
					break;
				case "activateButton":
					parent.event.activate.button = prefs.getIntPref("activateButton");
					break;
				case "activateAction":
					parent.event.activate.action = prefs.getIntPref("activateAction");
					break;
				case "cancelKey":
					parent.event.cancelKey = prefs.getIntPref("cancelKey");
					break;
				case "exitAction":
					parent.event.exitAction = prefs.getIntPref("exitAction");
					break;
				case "actionTool":
					parent.action[pname.split('.')[2]].tool = parent.tool.newByCode(prefs.getIntPref("actionTool." + pname.split('.')[2]), parent);
					break;
				case "actionMultiplier":
					parent.action[pname.split('.')[2]].settings.multiplier = parseFloat(prefs.getCharPref("actionMultiplier." + pname.split('.')[2]));
					break;
				case "actionExponent":
					parent.action[pname.split('.')[2]].settings.exponent = parseFloat(prefs.getCharPref("actionExponent." + pname.split('.')[2]));
					break;
				case "actionSize":
					parent.action[pname.split('.')[2]].settings.size = prefs.getIntPref("actionSize." + pname.split('.')[2]);
					break;
				case "actionAppearance":
					parent.action[pname.split('.')[2]].settings.appearance = prefs.getIntPref("actionAppearance." + pname.split('.')[2]);
					break;
			}
		} catch (ex) {
			;
		}
	} }
}

Multiscroll.Preferences = function(parent) {
	this.parent = parent;
};
Multiscroll.Preferences.prototype.load = function() { with (multiscroll) {
	var index;
	try {
		event.activate.shift = prefsObserver.prefs.getBoolPref("activateShiftOn");
		event.activate.ctrl = prefsObserver.prefs.getBoolPref("activateCtrlOn");
		event.activate.alt = prefsObserver.prefs.getBoolPref("activateAltOn");
		event.activate.meta = prefsObserver.prefs.getBoolPref("activateMetaOn");
		event.activate.button = prefsObserver.prefs.getIntPref("activateButton");
		event.activate.action = prefsObserver.prefs.getIntPref("activateAction");
		event.cancelKey = prefsObserver.prefs.getIntPref("cancelKey");
		event.exitAction = prefsObserver.prefs.getIntPref("exitAction");
		for (index in action) {
			action[index].tool = tool.newByCode(prefsObserver.prefs.getIntPref("actionTool." + index), multiscroll);
			action[index].settings.multiplier = parseFloat(prefsObserver.prefs.getCharPref("actionMultiplier." + index));
			action[index].settings.exponent = parseFloat(prefsObserver.prefs.getCharPref("actionExponent." + index));
			action[index].settings.size = prefsObserver.prefs.getIntPref("actionSize." + index);
			action[index].settings.appearance = prefsObserver.prefs.getIntPref("actionAppearance." + index);
		}
	} catch(ex) {
		prefsObserver.prefs.setBoolPref("activateShiftOn", event.activate.shift);
		prefsObserver.prefs.setBoolPref("activateCtrlOn", event.activate.ctrl);
		prefsObserver.prefs.setBoolPref("activateAltOn", event.activate.alt);
		prefsObserver.prefs.setBoolPref("activateMetaOn", event.activate.meta);
		prefsObserver.prefs.setIntPref("activateButton", event.activate.button);
		prefsObserver.prefs.setIntPref("activateAction", event.activate.action);
		prefsObserver.prefs.setIntPref("cancelKey", event.cancelKey);
		prefsObserver.prefs.setIntPref("exitAction", event.exitAction);
		for (index in action) {
			prefsObserver.prefs.setIntPref("actionTool." + index, tool.code(action[index].tool));
			prefsObserver.prefs.setCharPref("actionMultiplier." + index, String(action[index].settings.multiplier));
			prefsObserver.prefs.setCharPref("actionExponent." + index, String(action[index].settings.exponent));
			prefsObserver.prefs.setIntPref("actionSize." + index, action[index].settings.size);
			prefsObserver.prefs.setIntPref("actionAppearance." + index, action[index].settings.appearance);
		}
	}
} };
